Math = {}

function Math:ProcessMath(a)
	-- ignore any string that includes characters other than those listed here
	if not string.find(a,"^[()*/+%^-0123456789. ]+$") then return end
	-- strip spaces so gsub/find below always work
	-- save original as expr so it can be printed out as it was entered
	local expr = a
	a = gsub(a," ","")
	-- can't handle (3+3)^2 without lots of coding headaches. ignore any equations like that
	if string.find(a,"[()]%^") or string.find(a,"%^[()]") then return end
	-- replace x^y with lua's whacky ldexp function
	a = gsub(a,"([%d%.]+)^([%d%.]+)","(ldexp(%1,%2-1))")
	-- assume multiplication as default operation for parenthesis: 2(1+1) = 2*(1+1)
	a = gsub(a,"(%d)%(","%1*(")
	a = gsub(a,"%)([%d%.])",")*%1")
	a = gsub(a,"%)%(",")*(")
	-- check if the equation begins with an operator
	local _,_,first = string.find(a,"^([*/+-])")

	if first and Math.previous then
		a = Math.previous .. ' ' .. a
	elseif first then return end

	RunScript('Math:Print("'.. expr .. ' = " .. ' .. a .. ')')
	RunScript('Math.previous = ' .. a)
end

function Math:Print(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cff87cefaMath|r: " .. text)
end

SlashCmdList["MATH"] = function(...) Math:ProcessMath(...) end
SLASH_MATH1 = "/math"